'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-bdeef4f4.js');
const defaultIconPack = require('./default-icon-pack-0ea0e986.js');
const index$1 = require('./index-dbc5b08f.js');
const store = require('./store-d570e98c.js');
require('./default-language-4c779255.js');

const dyteSettingsToggleCss = ":host{display:block;font-family:var(--dyte-font-family, sans-serif)}";

const DyteSettingsToggle = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.stateUpdate = index.createEvent(this, "dyteStateUpdate", 7);
    /** Variant */
    this.variant = 'button';
    /** Icon pack */
    this.iconPack = defaultIconPack.defaultIconPack;
    /** Language */
    this.t = index$1.useLanguage();
  }
  toggleSettings() {
    var _a;
    this.stateUpdate.emit({ activeSettings: !((_a = this.states) === null || _a === void 0 ? void 0 : _a.activeSettings) });
    store.state.activeSettings = !store.state.activeSettings;
  }
  render() {
    const text = this.t('settings');
    return (index.h(index.Host, { title: text }, index.h("dyte-controlbar-button", { part: "controlbar-button", size: this.size, iconPack: this.iconPack, onClick: () => this.toggleSettings(), icon: this.iconPack.settings, label: text, variant: this.variant })));
  }
};
DyteSettingsToggle.style = dyteSettingsToggleCss;

exports.dyte_settings_toggle = DyteSettingsToggle;
