'use strict';

// NOTE:(callmetarush) This file is just till
// we support both V1 and V2 api's.
const isV2Permissions = (permissions) => {
  return 'requestProduceVideo' in permissions;
};
const isV2Theme = (theme) => {
  return !('controlBar' in theme);
};
exports.ProduceType = void 0;
(function (ProduceType) {
  ProduceType[ProduceType["Video"] = 0] = "Video";
  ProduceType[ProduceType["ScreenShare"] = 1] = "ScreenShare";
})(exports.ProduceType || (exports.ProduceType = {}));
const canProduce = (produceType, permissions) => {
  switch (produceType) {
    case exports.ProduceType.Video: {
      return ((isV2Permissions(permissions)
        ? permissions.produceVideo
        : permissions.produceVideo.allow) === 'ALLOWED');
    }
    case exports.ProduceType.ScreenShare: {
      return ((isV2Permissions(permissions)
        ? permissions.produceScreenshare
        : permissions.produceScreenshare.allow) === 'ALLOWED');
    }
  }
};

exports.canProduce = canProduce;
exports.isV2Permissions = isV2Permissions;
exports.isV2Theme = isV2Theme;
