import { r as registerInstance, h, H as Host } from './index-74ddb327.js';
import { s as shorten, f as formatName } from './string-133d57e8.js';
import { u as useLanguage } from './index-a214afbc.js';
import './default-language-04851639.js';

const dyteNameTagCss = ":host{display:inline-flex;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;align-items:center;padding-top:var(--dyte-space-1, 4px);padding-bottom:var(--dyte-space-1, 4px);padding-left:var(--dyte-space-1\\.5, 6px);padding-right:var(--dyte-space-1\\.5, 6px);font-size:14px;border-radius:var(--dyte-border-radius-sm, 4px);--tw-bg-opacity:1;background-color:rgba(var(--dyte-colors-background-700, 44 44 44) / var(--tw-bg-opacity));color:rgb(var(--dyte-colors-text-900, 255 255 255 / 0.88));font-family:var(--dyte-font-family, sans-serif)}span.name{overflow:hidden;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:1}::slotted(dyte-audio-visualizer[slot='start']){margin-right:var(--dyte-space-1\\.5, 6px)}::slotted(dyte-audio-visualizer[slot='end']){margin-left:var(--dyte-space-1\\.5, 6px)}:host([size='sm']){font-size:12px;--tw-bg-opacity:0.6}";

const DyteNameTag = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    /** Maximum length of the name */
    this.maxLength = 20;
    /** Whether it is used in a screen share view */
    this.isScreenShare = false;
    /** Language */
    this.t = useLanguage();
    this.length = 13;
  }
  sizeChanged(size) {
    this.length = size === 'sm' ? 8 : 13;
  }
  formatNameTag(name, isSelf) {
    return !this.isScreenShare
      ? isSelf
        ? `${shorten(name, this.length - 3)} (${this.t('you')})`
        : shorten(name, this.length)
      : isSelf
        ? `${this.t('Screen')} - ${shorten(name, this.length - 3)} (${this.t('you')})`
        : `${this.t('Screen')} - ${shorten(name, this.length)}`;
  }
  render() {
    var _a, _b, _c;
    const name = formatName(((_a = this.participant) === null || _a === void 0 ? void 0 : _a.name) || '');
    const isSelf = ((_b = this.participant) === null || _b === void 0 ? void 0 : _b.id) === ((_c = this.meeting) === null || _c === void 0 ? void 0 : _c.self.id);
    return (h(Host, { title: name }, h("slot", { name: "start" }), h("span", { class: "name" }, this.formatNameTag(name, isSelf)), h("slot", { name: "end" })));
  }
  static get watchers() { return {
    "size": ["sizeChanged"]
  }; }
};
DyteNameTag.style = dyteNameTagCss;

export { DyteNameTag as dyte_name_tag };
