import { IconPack } from '../../lib/icons';
import { Peer } from '../../types/dyte-client';
import { Size, States } from '../../types/props';
import { UIConfig } from '../../types/ui-config';
export declare type VideoState = Pick<Peer, 'videoEnabled' | 'videoTrack'>;
/**
 * A component which plays a participants video and allows for placement
 * of components like `dyte-name-tag`, `dyte-audio-visualizer` or any other component.
 */
export declare class DyteParticipantTile {
  private videoEl;
  videoState: VideoState;
  isPinned: boolean;
  /** Position of name tag */
  nameTagPosition: 'bottom-left' | 'bottom-right' | 'bottom-center' | 'top-left' | 'top-right' | 'top-center';
  /** Whether tile is used for preview */
  isPreview: boolean;
  /** Participant object */
  participant: Peer;
  /** States object */
  states: States;
  /** Config object */
  config: UIConfig;
  /** Variant */
  variant: 'solid' | 'gradient';
  /** Size */
  size: Size;
  /** Icon pack */
  iconPack: IconPack;
  /** Language */
  t: import("../../lib/lang").DyteI18n;
  connectedCallback(): void;
  componentDidLoad(): void;
  disconnectedCallback(): void;
  participantsChanged(participant: Peer): void;
  videoStateChanged(videoState: VideoState): void;
  private onVideoUpdate;
  private onPinned;
  private onPreviewUpdate;
  private isMirrored;
  render(): any;
}
